#   Copyright (C) 2009 B. Clausius
#   Copyright (c) 2004 Dale Mellor
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.


# Procedure which generates a list of lists of three random items, and sends it
# to gnubik-rotate-animated. The three random components are the face number
# (0, 1 or 2), the slice number (-(size-1), ..., size-3, size-1), and the
# direction to turn the slice (0 or 1).
def gnubik_randomize (num):
    size = gnubik_cube_state()[0][2]
    #
    #def loop(num, ret=[]):
    #    if (num == 0):
    #        return ret
    #    else:
    #        return loop(num-1, [(random(3), 2*random(size) - (size-1), random(2))] + ret)
    #
    #gnubik_rotate_animated(loop(num))
    moves = [(random(3), 2*random(size) - (size-1), random(2)) for i in xrange(num)]
    gnubik_rotate_animated(moves)

# Invoke the above procedure from a good few menu items for the convenience of
# the user.
scripts = [
        ('/'.join((_('Randomize'),_('Animated'),_('1 Move'))),  lambda: gnubik_randomize(1)),
        ('/'.join((_('Randomize'),_('Animated'),_('2 Moves'))), lambda: gnubik_randomize(2)),
        ('/'.join((_('Randomize'),_('Animated'),_('3 Moves'))), lambda: gnubik_randomize(3)),
        ('/'.join((_('Randomize'),_('Animated'),_('4 Moves'))), lambda: gnubik_randomize(4)),
        ('/'.join((_('Randomize'),_('Animated'),_('5 Moves'))), lambda: gnubik_randomize(5)),
        ('/'.join((_('Randomize'),_('Animated'),_('6 Moves'))), lambda: gnubik_randomize(6)),
        ('/'.join((_('Randomize'),_('Animated'),_('7 Moves'))), lambda: gnubik_randomize(7)),
        ('/'.join((_('Randomize'),_('Animated'),_('8 Moves'))), lambda: gnubik_randomize(8)),

        ('/'.join((_('Randomize'),_('Fast'),_('1 Move'))),      lambda: (gnubik_randomize(1),   gnubik_run_moves)),
        ('/'.join((_('Randomize'),_('Fast'),_('2 Moves'))),     lambda: (gnubik_randomize(2),   gnubik_run_moves)),
        ('/'.join((_('Randomize'),_('Fast'),_('4 Moves'))),     lambda: (gnubik_randomize(4),   gnubik_run_moves)),
        ('/'.join((_('Randomize'),_('Fast'),_('8 Moves'))),     lambda: (gnubik_randomize(8),   gnubik_run_moves)),
        ('/'.join((_('Randomize'),_('Fast'),_('16 Moves'))),    lambda: (gnubik_randomize(16),  gnubik_run_moves)),
        ('/'.join((_('Randomize'),_('Fast'),_('32 Moves'))),    lambda: (gnubik_randomize(32),  gnubik_run_moves)),
        ('/'.join((_('Randomize'),_('Fast'),_('64 Moves'))),    lambda: (gnubik_randomize(64),  gnubik_run_moves)),
        ('/'.join((_('Randomize'),_('Fast'),_('128 Moves'))),   lambda: (gnubik_randomize(128), gnubik_run_moves)),
    ]

